

import pyflow_acdc as pyf
import pandas as pd


def NS_MTDC():    
    
    S_base=100
    
    # DataFrame Code:
    nodes_AC_data = [
        {'type': 'PV', 'Voltage_0': 1.095, 'theta_0': 0.045588, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'BE1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 2.845459, 'y_coord': 51.158677, 'PZ': 'BE', 'geometry': 'POINT (2.845459 51.158677)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': 0.058503437, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'BE2', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 2.470551, 'y_coord': 51.364921, 'PZ': 'o_BE', 'geometry': 'POINT (2.470551 51.364921)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 13.0, 'Reactive_load': 0.0, 'Node_id': 'BE4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 3.469108902, 'y_coord': 50.78246468, 'PZ': 'BE', 'geometry': 'POINT (3.469108902 50.78246468)'},
        {'type': 'PV', 'Voltage_0': 1.084, 'theta_0': -0.024521876, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'BE5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 3.315546586, 'y_coord': 51.22725327, 'PZ': 'BE', 'geometry': 'POINT (3.315546586 51.22725327)'},
        {'type': 'PQ', 'Voltage_0': 1.086, 'theta_0': -0.066497045, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'BE6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.246895926, 'y_coord': 51.1540967, 'PZ': 'BE', 'geometry': 'POINT (4.246895926 51.1540967)'},
        {'type': 'PQ', 'Voltage_0': 1.084, 'theta_0': -0.101438536, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 13.0, 'Reactive_load': 0.0, 'Node_id': 'BE7', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.231690642, 'y_coord': 50.88088324, 'PZ': 'BE', 'geometry': 'POINT (4.231690642 50.88088324)'},
        {'type': 'PQ', 'Voltage_0': 1.087, 'theta_0': -0.065135688, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 13.0, 'Reactive_load': 0.0, 'Node_id': 'BE8', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.307260504, 'y_coord': 51.30118844, 'PZ': 'BE', 'geometry': 'POINT (4.307260504 51.30118844)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 25.0, 'Reactive_load': 0.0, 'Node_id': 'DE1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 7.309198552, 'y_coord': 53.12601855, 'PZ': 'DE', 'geometry': 'POINT (7.309198552 53.12601855)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': 0.291347812, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DE2', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.052802725, 'y_coord': 53.33233869, 'PZ': 'DE', 'geometry': 'POINT (8.052802725 53.33233869)'},
        {'type': 'PQ', 'Voltage_0': 1.099, 'theta_0': 0.243089458, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 25.0, 'Reactive_load': 0.0, 'Node_id': 'DE3', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.402753252, 'y_coord': 53.23674861, 'PZ': 'DE', 'geometry': 'POINT (8.402753252 53.23674861)'},
        {'type': 'PQ', 'Voltage_0': 1.094, 'theta_0': 0.156433861, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 25.0, 'Reactive_load': 0.0, 'Node_id': 'DE4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.501948888, 'y_coord': 53.54291062, 'PZ': 'DE', 'geometry': 'POINT (9.501948888 53.54291062)'},
        {'type': 'PQ', 'Voltage_0': 1.092, 'theta_0': 0.151442219, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DE5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.6379897, 'y_coord': 53.6426478, 'PZ': 'DE', 'geometry': 'POINT (9.6379897 53.6426478)'},
        {'type': 'PQ', 'Voltage_0': 1.096, 'theta_0': 0.137078159, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 25.0, 'Reactive_load': 0.0, 'Node_id': 'DE6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 10.15947704, 'y_coord': 53.55537458, 'PZ': 'DE', 'geometry': 'POINT (10.15947704 53.55537458)'},
        {'type': 'PV', 'Voltage_0': 1.099, 'theta_0': 0.157882484, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DE7', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.341514177, 'y_coord': 53.92326061, 'PZ': 'DE', 'geometry': 'POINT (9.341514177 53.92326061)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': 0.167045463, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DE8', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.201525929, 'y_coord': 53.89571897, 'PZ': 'DE', 'geometry': 'POINT (9.201525929 53.89571897)'},
        {'type': 'PQ', 'Voltage_0': 1.1, 'theta_0': 0.134529979, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DE9', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.725769967, 'y_coord': 54.28768538, 'PZ': 'DE', 'geometry': 'POINT (9.725769967 54.28768538)'},
        {'type': 'PQ', 'Voltage_0': 1.092, 'theta_0': 0.095172804, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DK1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.269876333, 'y_coord': 55.03683248, 'PZ': 'DK', 'geometry': 'POINT (9.269876333 55.03683248)'},
        {'type': 'PV', 'Voltage_0': 1.096, 'theta_0': 0.108646746, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 1.2, 'Reactive_load': 0.0, 'Node_id': 'DK2', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.9161039, 'y_coord': 55.5286593, 'PZ': 'DK', 'geometry': 'POINT (8.9161039 55.5286593)'},
        {'type': 'PV', 'Voltage_0': 1.093, 'theta_0': 0.099012528, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DK3', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.167976905, 'y_coord': 55.50508207, 'PZ': 'DK', 'geometry': 'POINT (9.167976905 55.50508207)'},
        {'type': 'Slack', 'Voltage_0': 1.084, 'theta_0': 0.086323985, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 7.0, 'Reactive_load': 0.0, 'Node_id': 'DK4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.546964567, 'y_coord': 55.56399285, 'PZ': 'DK', 'geometry': 'POINT (9.546964567 55.56399285)'},
        {'type': 'PV', 'Voltage_0': 1.095, 'theta_0': 0.106796697, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DK5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.706863041, 'y_coord': 55.53174507, 'PZ': 'DK', 'geometry': 'POINT (8.706863041 55.53174507)'},
        {'type': 'PV', 'Voltage_0': 1.091, 'theta_0': 0.101647976, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'DK6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.552944588, 'y_coord': 56.35138683, 'PZ': 'DK', 'geometry': 'POINT (8.552944588 56.35138683)'},
        {'type': 'PV', 'Voltage_0': 1.084, 'theta_0': 0.081384703, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 3.4, 'Reactive_load': 0.0, 'Node_id': 'DK7', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.566672108, 'y_coord': 56.47798039, 'PZ': 'DK', 'geometry': 'POINT (9.566672108 56.47798039)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 3.0, 'Reactive_load': 0.0, 'Node_id': 'GB1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.743259312, 'y_coord': 54.97763398, 'PZ': 'GB', 'geometry': 'POINT (-1.743259312 54.97763398)'},
        {'type': 'PQ', 'Voltage_0': 0.957, 'theta_0': -0.094736472, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB3', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.822070901, 'y_coord': 53.90040029, 'PZ': 'GB', 'geometry': 'POINT (-0.822070901 53.90040029)'},
        {'type': 'PQ', 'Voltage_0': 0.962, 'theta_0': -0.114895025, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 13.0, 'Reactive_load': 0.0, 'Node_id': 'GB4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.992442548, 'y_coord': 53.73621727, 'PZ': 'GB', 'geometry': 'POINT (-0.992442548 53.73621727)'},
        {'type': 'PQ', 'Voltage_0': 0.966, 'theta_0': -0.109920836, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.0692832, 'y_coord': 53.6366337, 'PZ': 'GB', 'geometry': 'POINT (-1.0692832 53.6366337)'},
        {'type': 'PQ', 'Voltage_0': 0.971, 'theta_0': -0.10273008, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.756037109, 'y_coord': 53.59806107, 'PZ': 'GB', 'geometry': 'POINT (-0.756037109 53.59806107)'},
        {'type': 'PQ', 'Voltage_0': 0.964, 'theta_0': -0.114266706, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB10', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.80883446, 'y_coord': 53.35935915, 'PZ': 'GB', 'geometry': 'POINT (-0.80883446 53.35935915)'},
        {'type': 'PQ', 'Voltage_0': 0.943, 'theta_0': -0.151145513, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 8.0, 'Reactive_load': 0.0, 'Node_id': 'GB11', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.255163941, 'y_coord': 52.86364381, 'PZ': 'GB', 'geometry': 'POINT (-1.255163941 52.86364381)'},
        {'type': 'PQ', 'Voltage_0': 0.953, 'theta_0': -0.128979832, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB12', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.219808814, 'y_coord': 52.93205225, 'PZ': 'GB', 'geometry': 'POINT (-0.219808814 52.93205225)'},
        {'type': 'PQ', 'Voltage_0': 0.942, 'theta_0': -0.14105751, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB13', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 0.198779153, 'y_coord': 52.72672158, 'PZ': 'GB', 'geometry': 'POINT (0.198779153 52.72672158)'},
        {'type': 'PV', 'Voltage_0': 0.932, 'theta_0': -0.140010313, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB14', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 1.272295269, 'y_coord': 52.57403635, 'PZ': 'GB', 'geometry': 'POINT (1.272295269 52.57403635)'},
        {'type': 'PQ', 'Voltage_0': 0.909, 'theta_0': -0.123063166, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB15', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.907568308, 'y_coord': 51.92634688, 'PZ': 'GB', 'geometry': 'POINT (-0.907568308 51.92634688)'},
        {'type': 'PQ', 'Voltage_0': 0.918, 'theta_0': -0.164863801, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB16', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.500739962, 'y_coord': 51.93429316, 'PZ': 'GB', 'geometry': 'POINT (-0.500739962 51.93429316)'},
        {'type': 'PQ', 'Voltage_0': 0.923, 'theta_0': -0.162228354, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB17', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.249326346, 'y_coord': 51.92769348, 'PZ': 'GB', 'geometry': 'POINT (-0.249326346 51.92769348)'},
        {'type': 'PQ', 'Voltage_0': 0.922, 'theta_0': -0.166085532, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB18', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 0.118460111, 'y_coord': 51.93505282, 'PZ': 'GB', 'geometry': 'POINT (0.118460111 51.93505282)'},
        {'type': 'PQ', 'Voltage_0': 0.917, 'theta_0': -0.147305789, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB19', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 0.7255421, 'y_coord': 52.00039309, 'PZ': 'GB', 'geometry': 'POINT (0.7255421 52.00039309)'},
        {'type': 'PQ', 'Voltage_0': 0.922, 'theta_0': -0.139015475, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB20', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 1.061598413, 'y_coord': 52.07118579, 'PZ': 'GB', 'geometry': 'POINT (1.061598413 52.07118579)'},
        {'type': 'PQ', 'Voltage_0': 0.9, 'theta_0': -0.033684855, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 10.0, 'Reactive_load': 0.0, 'Node_id': 'GB21', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.190382085, 'y_coord': 51.71111384, 'PZ': 'GB', 'geometry': 'POINT (-1.190382085 51.71111384)'},
        {'type': 'PQ', 'Voltage_0': 0.902, 'theta_0': -0.257558238, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 55.0, 'Reactive_load': 0.0, 'Node_id': 'GB22', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.095886403, 'y_coord': 51.53039835, 'PZ': 'GB', 'geometry': 'POINT (-0.095886403 51.53039835)'},
        {'type': 'PQ', 'Voltage_0': 0.9, 'theta_0': 0.036983527, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 10.0, 'Reactive_load': 0.0, 'Node_id': 'GB23', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.077280275, 'y_coord': 51.33629201, 'PZ': 'GB', 'geometry': 'POINT (-1.077280275 51.33629201)'},
        {'type': 'PV', 'Voltage_0': 0.905, 'theta_0': -0.138806035, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB24', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 0.715474718, 'y_coord': 51.44475984, 'PZ': 'GB', 'geometry': 'POINT (0.715474718 51.44475984)'},
        {'type': 'PQ', 'Voltage_0': 0.902, 'theta_0': 0.096237455, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 10.0, 'Reactive_load': 0.0, 'Node_id': 'GB25', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -1.039880887, 'y_coord': 50.91705623, 'PZ': 'GB', 'geometry': 'POINT (-1.039880887 50.91705623)'},
        {'type': 'PV', 'Voltage_0': 0.906, 'theta_0': -0.07845255, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB26', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 1.096375597, 'y_coord': 51.29372071, 'PZ': 'GB', 'geometry': 'POINT (1.096375597 51.29372071)'},
        {'type': 'PV', 'Voltage_0': 0.966, 'theta_0': -0.114388879, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'GB27', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': -0.178528, 'y_coord': 53.345633, 'PZ': 'GB', 'geometry': 'POINT (-0.178528 53.345633)'},
        {'type': 'PV', 'Voltage_0': 1.098, 'theta_0': -0.010960668, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.022206683, 'y_coord': 51.95508818, 'PZ': 'NL', 'geometry': 'POINT (4.022206683 51.95508818)'},
        {'type': 'PQ', 'Voltage_0': 1.099, 'theta_0': -0.003054326, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL2', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.530380423, 'y_coord': 52.03622457, 'PZ': 'NL', 'geometry': 'POINT (4.530380423 52.03622457)'},
        {'type': 'PQ', 'Voltage_0': 1.098, 'theta_0': -0.006527531, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL3', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.630595239, 'y_coord': 51.91440439, 'PZ': 'NL', 'geometry': 'POINT (4.630595239 51.91440439)'},
        {'type': 'PQ', 'Voltage_0': 1.096, 'theta_0': -0.019338248, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 9.0, 'Reactive_load': 0.0, 'Node_id': 'NL4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.689296598, 'y_coord': 51.86395935, 'PZ': 'NL', 'geometry': 'POINT (4.689296598 51.86395935)'},
        {'type': 'PQ', 'Voltage_0': 1.095, 'theta_0': -0.021781709, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.747997957, 'y_coord': 51.8135143, 'PZ': 'NL', 'geometry': 'POINT (4.747997957 51.8135143)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 9.0, 'Reactive_load': 0.0, 'Node_id': 'NL6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.833331644, 'y_coord': 51.70026041, 'PZ': 'NL', 'geometry': 'POINT (4.833331644 51.70026041)'},
        {'type': 'PQ', 'Voltage_0': 1.1, 'theta_0': 0.021868976, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL7', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.679143231, 'y_coord': 52.47266212, 'PZ': 'NL', 'geometry': 'POINT (4.679143231 52.47266212)'},
        {'type': 'PQ', 'Voltage_0': 1.098, 'theta_0': 0.026965337, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 9.0, 'Reactive_load': 0.0, 'Node_id': 'NL8', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 5.014546856, 'y_coord': 52.33675991, 'PZ': 'NL', 'geometry': 'POINT (5.014546856 52.33675991)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': 0.033300882, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL9', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.803772, 'y_coord': 52.742943, 'PZ': 'NL', 'geometry': 'POINT (4.803772 52.742943)'},
        {'type': 'PQ', 'Voltage_0': 1.1, 'theta_0': 0.166486957, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 9.0, 'Reactive_load': 0.0, 'Node_id': 'NL10', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.190173188, 'y_coord': 52.529986, 'PZ': 'NL', 'geometry': 'POINT (6.190173188 52.529986)'},
        {'type': 'PQ', 'Voltage_0': 1.099, 'theta_0': 0.316916886, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NL11', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.950363917, 'y_coord': 53.1238217, 'PZ': 'NL', 'geometry': 'POINT (6.950363917 53.1238217)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': -0.02719223, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO1', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.847880732, 'y_coord': 58.27602567, 'PZ': 'NO', 'geometry': 'POINT (6.847880732 58.27602567)'},
        {'type': 'PV', 'Voltage_0': 1.1, 'theta_0': -0.01844813, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO2', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 7.900400665, 'y_coord': 58.25974981, 'PZ': 'NO', 'geometry': 'POINT (7.900400665 58.25974981)'},
        {'type': 'PV', 'Voltage_0': 1.098, 'theta_0': -0.029338985, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO3', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.753403351, 'y_coord': 58.6700317, 'PZ': 'NO', 'geometry': 'POINT (6.753403351 58.6700317)'},
        {'type': 'PQ', 'Voltage_0': 1.097, 'theta_0': -0.016877334, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO4', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 8.729767678, 'y_coord': 58.5882958, 'PZ': 'NO', 'geometry': 'POINT (8.729767678 58.5882958)'},
        {'type': 'PQ', 'Voltage_0': 1.081, 'theta_0': -0.099745567, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 5.0, 'Reactive_load': 0.0, 'Node_id': 'NO5', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 5.734215456, 'y_coord': 58.81638056, 'PZ': 'NO', 'geometry': 'POINT (5.734215456 58.81638056)'},
        {'type': 'PQ', 'Voltage_0': 1.085, 'theta_0': -0.039217548, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO6', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.663982725, 'y_coord': 59.06038454, 'PZ': 'NO', 'geometry': 'POINT (6.663982725 59.06038454)'},
        {'type': 'PQ', 'Voltage_0': 1.08, 'theta_0': -0.003804818, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'NO7', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 7.249616363, 'y_coord': 59.34605485, 'PZ': 'NO', 'geometry': 'POINT (7.249616363 59.34605485)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 5.0, 'Reactive_load': 0.0, 'Node_id': 'NO8', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 9.438009548, 'y_coord': 59.22410345, 'PZ': 'NO', 'geometry': 'POINT (9.438009548 59.22410345)'},
        {'type': 'PQ', 'Voltage_0': 1.07, 'theta_0': -0.000331613, 'kV_base': 380, 'Power_Gained': 0, 'Reactive_Gained': 0, 'Power_load': 5.0, 'Reactive_load': 0.0, 'Node_id': 'NO9', 'Umin': 0.9, 'Umax': 1.1, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.654956105, 'y_coord': 59.52990729, 'PZ': 'NO', 'geometry': 'POINT (6.654956105 59.52990729)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'OFW_DK', 'Umin': 1.0, 'Umax': 1.0, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 7.275696, 'y_coord': 56.527684, 'PZ': 'o_DK', 'geometry': 'POINT (7.275696 56.527684)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'OFW_NL', 'Umin': 1.0, 'Umax': 1.0, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 3.960571, 'y_coord': 53.12535, 'PZ': 'o_NL', 'geometry': 'POINT (3.960571 53.12535)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'OFW_DEC', 'Umin': 1.0, 'Umax': 1.0, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 6.389923, 'y_coord': 54.901093, 'PZ': 'o_DE', 'geometry': 'POINT (6.389923 54.901093)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'theta_0': 0.0, 'kV_base': 380, 'Power_Gained': 0.0, 'Reactive_Gained': 0.0, 'Power_load': 0.0, 'Reactive_load': 0.0, 'Node_id': 'OFW_NO', 'Umin': 1.0, 'Umax': 1.0, 'Gs': 0.0, 'Bs': 0.0, 'x_coord': 4.658203, 'y_coord': 57.522273, 'PZ': 'o_NO', 'geometry': 'POINT (4.658203 57.522273)'}
    ]
    nodes_AC = pd.DataFrame(nodes_AC_data)

    lines_AC_data = [
        {'fromNode': 'GB1', 'toNode': 'GB3', 'r': 0.0005817174515235457, 'x': 0.007796197215082969, 'g': 0.0, 'b': 4.115476323106137, 'MVA_rating': 6792.410446962109, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL2', 'geometry': 'LINESTRING (-1.743259312 54.97763398, -0.822070901 53.90040029)'},
        {'fromNode': 'GB3', 'toNode': 'GB4', 'r': 0.0001592797783933518, 'x': 0.002134673046987004, 'g': 0.0, 'b': 0.28171415306976527, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL3', 'geometry': 'LINESTRING (-0.822070901 53.90040029, -0.992442548 53.73621727)'},
        {'fromNode': 'GB3', 'toNode': 'GB6', 'r': 0.00034626038781163435, 'x': 0.004640593580406529, 'g': 0.0, 'b': 0.6124220718907941, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL4', 'geometry': 'LINESTRING (-0.822070901 53.90040029, -0.756037109 53.59806107)'},
        {'fromNode': 'GB4', 'toNode': 'GB5', 'r': 7.617728531855956e-05, 'x': 0.0010209305876894366, 'g': 0.0, 'b': 0.13473285581597472, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL5', 'geometry': 'LINESTRING (-0.992442548 53.73621727, -1.0692832 53.6366337)'},
        {'fromNode': 'GB5', 'toNode': 'GB6', 'r': 0.000110803324099723, 'x': 0.0014849899457300894, 'g': 0.0, 'b': 0.19597506300505413, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL6', 'geometry': 'LINESTRING (-1.0692832 53.6366337, -0.756037109 53.59806107)'},
        {'fromNode': 'GB6', 'toNode': 'GB10', 'r': 5.54016620498615e-05, 'x': 0.0007424949728650447, 'g': 0.0, 'b': 0.39195012601010826, 'MVA_rating': 6792.410446962109, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL10', 'geometry': 'LINESTRING (-0.756037109 53.59806107, -0.80883446 53.35935915)'},
        {'fromNode': 'GB10', 'toNode': 'GB11', 'r': 0.00045706371191135735, 'x': 0.00612558352613662, 'g': 0.0, 'b': 0.8083971348958483, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL11', 'geometry': 'LINESTRING (-0.80883446 53.35935915, -1.255163941 52.86364381)'},
        {'fromNode': 'GB11', 'toNode': 'GB15', 'r': 0.0006925207756232687, 'x': 0.009281187160813059, 'g': 0.0, 'b': 1.2248441437815882, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL12', 'geometry': 'LINESTRING (-1.255163941 52.86364381, -0.907568308 51.92634688)'},
        {'fromNode': 'GB10', 'toNode': 'GB16', 'r': 0.001066481994459834, 'x': 0.014293028227652112, 'g': 0.0, 'b': 1.886259981423646, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL13', 'geometry': 'LINESTRING (-0.80883446 53.35935915, -0.500739962 51.93429316)'},
        {'fromNode': 'GB10', 'toNode': 'GB17', 'r': 0.001066481994459834, 'x': 0.014293028227652112, 'g': 0.0, 'b': 1.886259981423646, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL14', 'geometry': 'LINESTRING (-0.80883446 53.35935915, -0.249326346 51.92769348)'},
        {'fromNode': 'GB10', 'toNode': 'GB12', 'r': 0.0003739612188365651, 'x': 0.005011841066839052, 'g': 0.0, 'b': 0.6614158376420577, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL15', 'geometry': 'LINESTRING (-0.80883446 53.35935915, -0.219808814 52.93205225)'},
        {'fromNode': 'GB12', 'toNode': 'GB13', 'r': 0.00030470914127423825, 'x': 0.004083722350757746, 'g': 0.0, 'b': 0.5389314232638989, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL16', 'geometry': 'LINESTRING (-0.219808814 52.93205225, 0.198779153 52.72672158)'},
        {'fromNode': 'GB13', 'toNode': 'GB18', 'r': 0.0006024930747922437, 'x': 0.008074632829907362, 'g': 0.0, 'b': 1.0656144050899818, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL17', 'geometry': 'LINESTRING (0.198779153 52.72672158, 0.118460111 51.93505282)'},
        {'fromNode': 'GB13', 'toNode': 'GB14', 'r': 0.0005609418282548476, 'x': 0.007517761600258578, 'g': 0.0, 'b': 0.9921237564630865, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL18', 'geometry': 'LINESTRING (0.198779153 52.72672158, 1.272295269 52.57403635)'},
        {'fromNode': 'GB14', 'toNode': 'GB20', 'r': 0.00036703601108033245, 'x': 0.004919029195230921, 'g': 0.0, 'b': 0.6491673962042418, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL19', 'geometry': 'LINESTRING (1.272295269 52.57403635, 1.061598413 52.07118579)'},
        {'fromNode': 'GB15', 'toNode': 'GB16', 'r': 0.00019390581717451525, 'x': 0.0025987324050276567, 'g': 0.0, 'b': 0.34295636025884474, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL20', 'geometry': 'LINESTRING (-0.907568308 51.92634688, -0.500739962 51.93429316)'},
        {'fromNode': 'GB16', 'toNode': 'GB17', 'r': 0.000110803324099723, 'x': 0.0014849899457300894, 'g': 0.0, 'b': 0.19597506300505413, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL21', 'geometry': 'LINESTRING (-0.500739962 51.93429316, -0.249326346 51.92769348)'},
        {'fromNode': 'GB17', 'toNode': 'GB18', 'r': 0.00017313019390581717, 'x': 0.0023202967902032647, 'g': 0.0, 'b': 0.30621103594539706, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL22', 'geometry': 'LINESTRING (-0.249326346 51.92769348, 0.118460111 51.93505282)'},
        {'fromNode': 'GB18', 'toNode': 'GB20', 'r': 0.00046398891966759005, 'x': 0.006218395397744749, 'g': 0.0, 'b': 0.8206455763336642, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL23', 'geometry': 'LINESTRING (0.118460111 51.93505282, 1.061598413 52.07118579)'},
        {'fromNode': 'GB18', 'toNode': 'GB19', 'r': 0.00047091412742382275, 'x': 0.0063112072693528795, 'g': 0.0, 'b': 0.20822350444287002, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL24', 'geometry': 'LINESTRING (0.118460111 51.93505282, 0.7255421 52.00039309)'},
        {'fromNode': 'GB19', 'toNode': 'GB20', 'r': 0.0004293628808864266, 'x': 0.0057543360397040964, 'g': 0.0, 'b': 0.18985084228614618, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL25', 'geometry': 'LINESTRING (0.7255421 52.00039309, 1.061598413 52.07118579)'},
        {'fromNode': 'GB15', 'toNode': 'GB21', 'r': 0.00017313019390581717, 'x': 0.0023202967902032647, 'g': 0.0, 'b': 0.30621103594539706, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL26', 'geometry': 'LINESTRING (-0.907568308 51.92634688, -1.190382085 51.71111384)'},
        {'fromNode': 'GB21', 'toNode': 'GB23', 'r': 0.0003116343490304709, 'x': 0.0041765342223658766, 'g': 0.0, 'b': 0.5511798647017148, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL27', 'geometry': 'LINESTRING (-1.190382085 51.71111384, -1.077280275 51.33629201)'},
        {'fromNode': 'GB15', 'toNode': 'GB22', 'r': 0.000533240997229917, 'x': 0.007146514113826056, 'g': 0.0, 'b': 0.943129990711823, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL28', 'geometry': 'LINESTRING (-0.907568308 51.92634688, -0.095886403 51.53039835)'},
        {'fromNode': 'GB16', 'toNode': 'GB22', 'r': 0.0003185595567867036, 'x': 0.004269346093974008, 'g': 0.0, 'b': 0.5634283061395305, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL29', 'geometry': 'LINESTRING (-0.500739962 51.93429316, -0.095886403 51.53039835)'},
        {'fromNode': 'GB18', 'toNode': 'GB22', 'r': 0.000554016620498615, 'x': 0.007424949728650447, 'g': 0.0, 'b': 0.24496882875631765, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL30', 'geometry': 'LINESTRING (0.118460111 51.93505282, -0.095886403 51.53039835)'},
        {'fromNode': 'GB19', 'toNode': 'GB24', 'r': 0.0003947368421052632, 'x': 0.005290276681663444, 'g': 0.0, 'b': 0.6981611619555053, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL31', 'geometry': 'LINESTRING (0.7255421 52.00039309, 0.715474718 51.44475984)'},
        {'fromNode': 'GB22', 'toNode': 'GB24', 'r': 0.0003739612188365651, 'x': 0.005011841066839052, 'g': 0.0, 'b': 0.6614158376420577, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL32', 'geometry': 'LINESTRING (-0.095886403 51.53039835, 0.715474718 51.44475984)'},
        {'fromNode': 'GB23', 'toNode': 'GB24', 'r': 0.0008310249307479224, 'x': 0.011137424592975672, 'g': 0.0, 'b': 1.4698129725379059, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL33', 'geometry': 'LINESTRING (-1.077280275 51.33629201, 0.715474718 51.44475984)'},
        {'fromNode': 'GB23', 'toNode': 'GB25', 'r': 0.0004155124653739612, 'x': 0.005568712296487836, 'g': 0.0, 'b': 0.7349064862689529, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL34', 'geometry': 'LINESTRING (-1.077280275 51.33629201, -1.039880887 50.91705623)'},
        {'fromNode': 'GB24', 'toNode': 'GB26', 'r': 0.00046398891966759005, 'x': 0.006218395397744749, 'g': 0.0, 'b': 0.8206455763336642, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL35', 'geometry': 'LINESTRING (0.715474718 51.44475984, 1.096375597 51.29372071)'},
        {'fromNode': 'GB25', 'toNode': 'GB26', 'r': 0.0013157894736842107, 'x': 0.017634255605544814, 'g': 0.0, 'b': 2.3272038731850175, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL36', 'geometry': 'LINESTRING (-1.039880887 50.91705623, 1.096375597 51.29372071)'},
        {'fromNode': 'GB10', 'toNode': 'GB27', 'r': 0.0003808864265927978, 'x': 0.005104652938447182, 'g': 0.0, 'b': 0.6736642790798736, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'GBL37', 'geometry': 'LINESTRING (-0.80883446 53.35935915, -0.178528 53.345633)'},
        {'fromNode': 'BE1', 'toNode': 'BE2', 'r': 0.000171398891966759, 'x': 0.0006200511816295644, 'g': 0.0, 'b': 20.822350444287004, 'MVA_rating': 3633.1497739564766, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL1', 'geometry': 'LINESTRING (2.845459 51.158677, 2.470551 51.364921)'},
        {'fromNode': 'BE1', 'toNode': 'BE4', 'r': 0.00034626038781163435, 'x': 0.004640593580406529, 'g': 0.0, 'b': 0.6124220718907941, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL2', 'geometry': 'LINESTRING (2.845459 51.158677, 3.469108902 50.78246468)'},
        {'fromNode': 'BE4', 'toNode': 'BE5', 'r': 0.00018005540166204988, 'x': 0.0024131086618113954, 'g': 0.0, 'b': 0.31845947738321295, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL4', 'geometry': 'LINESTRING (3.469108902 50.78246468, 3.315546586 51.22725327)'},
        {'fromNode': 'BE5', 'toNode': 'BE6', 'r': 0.0003116343490304709, 'x': 0.0041765342223658766, 'g': 0.0, 'b': 0.5511798647017148, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL5', 'geometry': 'LINESTRING (3.315546586 51.22725327, 4.246895926 51.1540967)'},
        {'fromNode': 'BE6', 'toNode': 'BE7', 'r': 0.00023545706371191138, 'x': 0.0031556036346764398, 'g': 0.0, 'b': 0.41644700888574004, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL6', 'geometry': 'LINESTRING (4.246895926 51.1540967, 4.231690642 50.88088324)'},
        {'fromNode': 'BE6', 'toNode': 'BE8', 'r': 9.695290858725763e-05, 'x': 0.0012993662025138283, 'g': 0.0, 'b': 0.17147818012942237, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'BEL7', 'geometry': 'LINESTRING (4.246895926 51.1540967, 4.307260504 51.30118844)'},
        {'fromNode': 'NL1', 'toNode': 'NL2', 'r': 0.0002493074792243767, 'x': 0.003341227377892701, 'g': 0.0, 'b': 0.4409438917613718, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL1', 'geometry': 'LINESTRING (4.022206683 51.95508818, 4.530380423 52.03622457)'},
        {'fromNode': 'NL1', 'toNode': 'NL5', 'r': 0.00034626038781163435, 'x': 0.004640593580406529, 'g': 0.0, 'b': 0.6124220718907941, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL2', 'geometry': 'LINESTRING (4.022206683 51.95508818, 4.747997957 51.8135143)'},
        {'fromNode': 'NL2', 'toNode': 'NL7', 'r': 0.00036703601108033245, 'x': 0.004919029195230921, 'g': 0.0, 'b': 0.6491673962042418, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL3', 'geometry': 'LINESTRING (4.530380423 52.03622457, 4.679143231 52.47266212)'},
        {'fromNode': 'NL2', 'toNode': 'NL3', 'r': 9.695290858725763e-05, 'x': 0.0012993662025138283, 'g': 0.0, 'b': 0.17147818012942237, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL4', 'geometry': 'LINESTRING (4.530380423 52.03622457, 4.630595239 51.91440439)'},
        {'fromNode': 'NL3', 'toNode': 'NL4', 'r': 0.0001038781163434903, 'x': 0.001392178074121959, 'g': 0.0, 'b': 0.18372662156723824, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL5', 'geometry': 'LINESTRING (4.630595239 51.91440439, 4.689296598 51.86395935)'},
        {'fromNode': 'NL4', 'toNode': 'NL5', 'r': 5.54016620498615e-05, 'x': 0.0007424949728650447, 'g': 0.0, 'b': 0.09798753150252706, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL6', 'geometry': 'LINESTRING (4.689296598 51.86395935, 4.747997957 51.8135143)'},
        {'fromNode': 'NL5', 'toNode': 'NL6', 'r': 9.002770083102494e-05, 'x': 0.0012065543309056977, 'g': 0.0, 'b': 0.15922973869160648, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL7', 'geometry': 'LINESTRING (4.747997957 51.8135143, 4.833331644 51.70026041)'},
        {'fromNode': 'NL3', 'toNode': 'NL8', 'r': 0.0003808864265927978, 'x': 0.005104652938447182, 'g': 0.0, 'b': 0.6736642790798736, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL8', 'geometry': 'LINESTRING (4.630595239 51.91440439, 5.014546856 52.33675991)'},
        {'fromNode': 'NL7', 'toNode': 'NL8', 'r': 0.00019390581717451525, 'x': 0.0025987324050276567, 'g': 0.0, 'b': 0.34295636025884474, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL9', 'geometry': 'LINESTRING (4.679143231 52.47266212, 5.014546856 52.33675991)'},
        {'fromNode': 'NL7', 'toNode': 'NL9', 'r': 0.0002700831024930748, 'x': 0.003619662992717093, 'g': 0.0, 'b': 0.47768921607481946, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL10', 'geometry': 'LINESTRING (4.679143231 52.47266212, 4.803772 52.742943)'},
        {'fromNode': 'NL8', 'toNode': 'NL10', 'r': 0.0006371191135734072, 'x': 0.008538692187948015, 'g': 0.0, 'b': 1.126856612279061, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL11', 'geometry': 'LINESTRING (5.014546856 52.33675991, 6.190173188 52.529986)'},
        {'fromNode': 'NL10', 'toNode': 'NL11', 'r': 0.0006786703601108033, 'x': 0.009095563417596798, 'g': 0.0, 'b': 1.2003472609059564, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NLL12', 'geometry': 'LINESTRING (6.190173188 52.529986, 6.950363917 53.1238217)'},
        {'fromNode': 'DE1', 'toNode': 'DE2', 'r': 0.00034626038781163435, 'x': 0.004640593580406529, 'g': 0.0, 'b': 0.6124220718907941, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL1', 'geometry': 'LINESTRING (7.309198552 53.12601855, 8.052802725 53.33233869)'},
        {'fromNode': 'DE2', 'toNode': 'DE3', 'r': 0.00023545706371191138, 'x': 0.0031556036346764398, 'g': 0.0, 'b': 0.41644700888574004, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL2', 'geometry': 'LINESTRING (8.052802725 53.33233869, 8.402753252 53.23674861)'},
        {'fromNode': 'DE3', 'toNode': 'DE4', 'r': 0.0005886426592797783, 'x': 0.007889009086691101, 'g': 0.0, 'b': 1.04111752221435, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL3', 'geometry': 'LINESTRING (8.402753252 53.23674861, 9.501948888 53.54291062)'},
        {'fromNode': 'DE4', 'toNode': 'DE6', 'r': 0.0004293628808864266, 'x': 0.0057543360397040964, 'g': 0.0, 'b': 0.7594033691445847, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL4', 'geometry': 'LINESTRING (9.501948888 53.54291062, 10.15947704 53.55537458)'},
        {'fromNode': 'DE4', 'toNode': 'DE5', 'r': 0.00011542012927054478, 'x': 0.0015468645268021765, 'g': 0.0, 'b': 0.4593165539180956, 'MVA_rating': 5094.307835221581, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL5', 'geometry': 'LINESTRING (9.501948888 53.54291062, 9.6379897 53.6426478)'},
        {'fromNode': 'DE5', 'toNode': 'DE6', 'r': 0.00019390581717451525, 'x': 0.0025987324050276567, 'g': 0.0, 'b': 0.34295636025884474, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL6', 'geometry': 'LINESTRING (9.6379897 53.6426478, 10.15947704 53.55537458)'},
        {'fromNode': 'DE6', 'toNode': 'DE8', 'r': 0.0004362880886426593, 'x': 0.0058471479113122275, 'g': 0.0, 'b': 0.7716518105824006, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL7', 'geometry': 'LINESTRING (10.15947704 53.55537458, 9.201525929 53.89571897)'},
        {'fromNode': 'DE7', 'toNode': 'DE8', 'r': 9.002770083102494e-05, 'x': 0.0012065543309056977, 'g': 0.0, 'b': 0.15922973869160648, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL8', 'geometry': 'LINESTRING (9.341514177 53.92326061, 9.201525929 53.89571897)'},
        {'fromNode': 'DE7', 'toNode': 'DE9', 'r': 0.0003116343490304709, 'x': 0.0041765342223658766, 'g': 0.0, 'b': 0.5511798647017148, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL9', 'geometry': 'LINESTRING (9.341514177 53.92326061, 9.725769967 54.28768538)'},
        {'fromNode': 'DE6', 'toNode': 'DE9', 'r': 0.00046398891966759005, 'x': 0.006218395397744749, 'g': 0.0, 'b': 0.8206455763336642, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL10', 'geometry': 'LINESTRING (10.15947704 53.55537458, 9.725769967 54.28768538)'},
        {'fromNode': 'DE5', 'toNode': 'DE7', 'r': 0.00024238227146814408, 'x': 0.003248415506284571, 'g': 0.0, 'b': 0.4286954503235559, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DEL11', 'geometry': 'LINESTRING (9.6379897 53.6426478, 9.341514177 53.92326061)'},
        {'fromNode': 'DK1', 'toNode': 'DK3', 'r': 0.00034626038781163435, 'x': 0.004640593580406529, 'g': 0.0, 'b': 0.6124220718907941, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL1', 'geometry': 'LINESTRING (9.269876333 55.03683248, 9.167976905 55.50508207)'},
        {'fromNode': 'DK1', 'toNode': 'DK4', 'r': 0.0008310249307479224, 'x': 0.011137424592975672, 'g': 0.0, 'b': 0.36745324313447647, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL2', 'geometry': 'LINESTRING (9.269876333 55.03683248, 9.546964567 55.56399285)'},
        {'fromNode': 'DK2', 'toNode': 'DK5', 'r': 0.00011772853185595569, 'x': 0.0015778018173382199, 'g': 0.0, 'b': 0.20822350444287002, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL3', 'geometry': 'LINESTRING (8.9161039 55.5286593, 8.706863041 55.53174507)'},
        {'fromNode': 'DK2', 'toNode': 'DK3', 'r': 9.695290858725763e-05, 'x': 0.0012993662025138283, 'g': 0.0, 'b': 0.17147818012942237, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL4', 'geometry': 'LINESTRING (8.9161039 55.5286593, 9.167976905 55.50508207)'},
        {'fromNode': 'DK3', 'toNode': 'DK4', 'r': 0.00019390581717451525, 'x': 0.0025987324050276567, 'g': 0.0, 'b': 0.34295636025884474, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL5', 'geometry': 'LINESTRING (9.167976905 55.50508207, 9.546964567 55.56399285)'},
        {'fromNode': 'DK5', 'toNode': 'DK6', 'r': 0.00033240997229916895, 'x': 0.004454969837190268, 'g': 0.0, 'b': 0.5879251890151623, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL6', 'geometry': 'LINESTRING (8.706863041 55.53174507, 8.552944588 56.35138683)'},
        {'fromNode': 'DK3', 'toNode': 'DK7', 'r': 0.0007825484764542938, 'x': 0.010487741491718756, 'g': 0.0, 'b': 1.3840738824731946, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL7', 'geometry': 'LINESTRING (9.167976905 55.50508207, 9.566672108 56.47798039)'},
        {'fromNode': 'DK6', 'toNode': 'DK7', 'r': 0.0013434903047091413, 'x': 0.018005503091977335, 'g': 0.0, 'b': 0.5940494097340703, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'DKL8', 'geometry': 'LINESTRING (8.552944588 56.35138683, 9.566672108 56.47798039)'},
        {'fromNode': 'NO1', 'toNode': 'NO2', 'r': 0.00110803324099723, 'x': 0.014849899457300895, 'g': 0.0, 'b': 0.4899376575126353, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL1', 'geometry': 'LINESTRING (6.847880732 58.27602567, 7.900400665 58.25974981)'},
        {'fromNode': 'NO1', 'toNode': 'NO3', 'r': 0.00029085872576177285, 'x': 0.0038980986075414846, 'g': 0.0, 'b': 0.5144345403882671, 'MVA_rating': 3396.2052234810544, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL2', 'geometry': 'LINESTRING (6.847880732 58.27602567, 6.753403351 58.6700317)'},
        {'fromNode': 'NO2', 'toNode': 'NO7', 'r': 0.002063711911357341, 'x': 0.027657937739222916, 'g': 0.0, 'b': 0.9125088871172833, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL3', 'geometry': 'LINESTRING (7.900400665 58.25974981, 7.249616363 59.34605485)'},
        {'fromNode': 'NO2', 'toNode': 'NO4', 'r': 0.0008725761772853186, 'x': 0.011694295822624455, 'g': 0.0, 'b': 0.3858259052912003, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL4', 'geometry': 'LINESTRING (7.900400665 58.25974981, 8.729767678 58.5882958)'},
        {'fromNode': 'NO3', 'toNode': 'NO6', 'r': 0.0007063711911357341, 'x': 0.009466810904029321, 'g': 0.0, 'b': 0.312335256664305, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL5', 'geometry': 'LINESTRING (6.753403351 58.6700317, 6.663982725 59.06038454)'},
        {'fromNode': 'NO3', 'toNode': 'NO4', 'r': 0.0017313019390581717, 'x': 0.023202967902032648, 'g': 0.0, 'b': 0.7655275898634927, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL6', 'geometry': 'LINESTRING (6.753403351 58.6700317, 8.729767678 58.5882958)'},
        {'fromNode': 'NO4', 'toNode': 'NO8', 'r': 0.0016481994459833795, 'x': 0.022089225442735082, 'g': 0.0, 'b': 0.728782265550045, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL7', 'geometry': 'LINESTRING (8.729767678 58.5882958, 9.438009548 59.22410345)'},
        {'fromNode': 'NO5', 'toNode': 'NO6', 'r': 0.0009418282548476455, 'x': 0.012622414538705759, 'g': 0.0, 'b': 0.41644700888574004, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL8', 'geometry': 'LINESTRING (5.734215456 58.81638056, 6.663982725 59.06038454)'},
        {'fromNode': 'NO6', 'toNode': 'NO9', 'r': 0.0007617728531855956, 'x': 0.010209305876894365, 'g': 0.0, 'b': 0.3368321395399368, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL9', 'geometry': 'LINESTRING (6.663982725 59.06038454, 6.654956105 59.52990729)'},
        {'fromNode': 'NO9', 'toNode': 'NO7', 'r': 0.000554016620498615, 'x': 0.007424949728650447, 'g': 0.0, 'b': 0.24496882875631765, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL10', 'geometry': 'LINESTRING (6.654956105 59.52990729, 7.249616363 59.34605485)'},
        {'fromNode': 'NO7', 'toNode': 'NO8', 'r': 0.0018698060941828255, 'x': 0.025059205334195263, 'g': 0.0, 'b': 0.826769797052572, 'MVA_rating': 1698.1026117405272, 'kV_base': 380, 'm': 1, 'shift': 0, 'Line_id': 'NOL11', 'geometry': 'LINESTRING (7.249616363 59.34605485, 9.438009548 59.22410345)'}
    ]
    lines_AC = pd.DataFrame(lines_AC_data)

    nodes_DC_data = [
        {'type': 'Slack', 'Voltage_0': 1.0, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC1', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 2.493896, 'y_coord': 51.387209, 'PZ': None, 'geometry': 'POINT (2.493896 51.387209)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC2', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 3.230667, 'y_coord': 50.901301, 'PZ': None, 'geometry': 'POINT (3.230667 50.901301)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC3', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 3.597507, 'y_coord': 51.113869, 'PZ': None, 'geometry': 'POINT (3.597507 51.113869)'},
        {'type': 'PAC', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC4', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 3.988037, 'y_coord': 53.067627, 'PZ': None, 'geometry': 'POINT (3.988037 53.067627)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC5', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 4.839478, 'y_coord': 52.782831, 'PZ': None, 'geometry': 'POINT (4.839478 52.782831)'},
        {'type': 'PAC', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC6', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 6.416016, 'y_coord': 54.85764, 'PZ': None, 'geometry': 'POINT (6.416016 54.85764)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC7', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 7.918396, 'y_coord': 53.366124, 'PZ': None, 'geometry': 'POINT (7.918396 53.366124)'},
        {'type': 'PAC', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC8', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 7.316895, 'y_coord': 56.46249, 'PZ': None, 'geometry': 'POINT (7.316895 56.46249)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC9', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 8.519897, 'y_coord': 56.353078, 'PZ': None, 'geometry': 'POINT (8.519897 56.353078)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC10', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': -0.126343, 'y_coord': 53.343993, 'PZ': None, 'geometry': 'POINT (-0.126343 53.343993)'},
        {'type': 'P', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'MTDC11', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 1.304626, 'y_coord': 52.579688, 'PZ': None, 'geometry': 'POINT (1.304626 52.579688)'},
        {'type': 'Slack', 'Voltage_0': 1.0, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'NODC1', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 6.679688, 'y_coord': 58.662725, 'PZ': None, 'geometry': 'POINT (6.679688 58.662725)'},
        {'type': 'PAC', 'Voltage_0': 1.01, 'Power_Gained': 0.0, 'Power_load': 0.0, 'kV_base': 525, 'Node_id': 'NODC2', 'Umin': 0.95, 'Umax': 1.05, 'x_coord': 4.75708, 'y_coord': 57.733971, 'PZ': None, 'geometry': 'POINT (4.75708 57.733971)'}
    ]
    nodes_DC = pd.DataFrame(nodes_DC_data)

    lines_DC_data = [
        {'fromNode': 'MTDC4', 'toNode': 'MTDC10', 'r': 0.0008961451247165532, 'MW_rating': 1800.75, 'kV_base': 525, 'Length_km': 260, 'Mono_Bi_polar': 'b', 'Line_id': 'LionLink', 'geometry': 'LINESTRING (3.988037 53.067627, -0.126343 53.343993)'},
        {'fromNode': 'MTDC1', 'toNode': 'MTDC11', 'r': 0.0004825396825396826, 'MW_rating': 1399.99999965, 'kV_base': 525, 'Length_km': 140, 'Mono_Bi_polar': 'b', 'Line_id': 'Nautilus', 'geometry': 'LINESTRING (2.493896 51.387209, 1.304626 52.579688)'},
        {'fromNode': 'MTDC1', 'toNode': 'MTDC8', 'r': 0.002068027210884354, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 600, 'Mono_Bi_polar': 'b', 'Line_id': 'TritonLink', 'geometry': 'LINESTRING (2.493896 51.387209, 7.316895 56.46249)'},
        {'fromNode': 'MTDC1', 'toNode': 'MTDC4', 'r': 0.0008616780045351474, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 250, 'Mono_Bi_polar': 'b', 'Line_id': 'BE-NL Link', 'geometry': 'LINESTRING (2.493896 51.387209, 3.988037 53.067627)'},
        {'fromNode': 'MTDC4', 'toNode': 'MTDC6', 'r': 0.0007410430839002268, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 215, 'Mono_Bi_polar': 'b', 'Line_id': 'DE-NL Link', 'geometry': 'LINESTRING (3.988037 53.067627, 6.416016 54.85764)'},
        {'fromNode': 'MTDC6', 'toNode': 'MTDC8', 'r': 0.0005687074829931972, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 165, 'Mono_Bi_polar': 'b', 'Line_id': 'DK-DE Link', 'geometry': 'LINESTRING (6.416016 54.85764, 7.316895 56.46249)'},
        {'fromNode': 'MTDC1', 'toNode': 'MTDC2', 'r': 0.00015510204081632654, 'MW_rating': 1399.99999965, 'kV_base': 525, 'Length_km': 45, 'Mono_Bi_polar': 'b', 'Line_id': 'BE Nautilus', 'geometry': 'LINESTRING (2.493896 51.387209, 3.230667 50.901301)'},
        {'fromNode': 'MTDC1', 'toNode': 'MTDC3', 'r': 0.0002412698412698413, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 70, 'Mono_Bi_polar': 'b', 'Line_id': 'BE TritonLink', 'geometry': 'LINESTRING (2.493896 51.387209, 3.597507 51.113869)'},
        {'fromNode': 'MTDC6', 'toNode': 'MTDC7', 'r': 0.0007582766439909297, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 220, 'Mono_Bi_polar': 'b', 'Line_id': 'DE HUB', 'geometry': 'LINESTRING (6.416016 54.85764, 7.918396 53.366124)'},
        {'fromNode': 'MTDC8', 'toNode': 'MTDC9', 'r': 0.00044117913832199544, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 128, 'Mono_Bi_polar': 'b', 'Line_id': 'DK HUB', 'geometry': 'LINESTRING (7.316895 56.46249, 8.519897 56.353078)'},
        {'fromNode': 'MTDC4', 'toNode': 'MTDC5', 'r': 0.0002757369614512472, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 80, 'Mono_Bi_polar': 'b', 'Line_id': 'NL HUB', 'geometry': 'LINESTRING (3.988037 53.067627, 4.839478 52.782831)'},
        {'fromNode': 'NODC1', 'toNode': 'NODC2', 'r': 0.00034467120181405896, 'MW_rating': 2000.00000025, 'kV_base': 525, 'Length_km': 100, 'Mono_Bi_polar': 'b', 'Line_id': 'NO HUB', 'geometry': 'LINESTRING (6.679688 58.662725, 4.75708 57.733971)'}
    ]
    lines_DC = pd.DataFrame(lines_DC_data)

    Converters_ACDC_data = [
        {'AC_type': 'PV', 'DC_type': 'Slack', 'AC_node': 'BE2', 'DC_node': 'MTDC1', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': -0.85, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.00125, 'PR_x': 0.03180538017064047, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 800.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC1', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (2.493896 51.387209, 2.470551 51.364921)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'BE1', 'DC_node': 'MTDC2', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': -0.99, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.00125, 'PR_x': 0.03180538017064047, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 800.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC2', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (3.230667 50.901301, 2.845459 51.158677)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'BE5', 'DC_node': 'MTDC3', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': -0.21, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1100.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC3', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (3.597507 51.113869, 3.315546586 51.22725327)'},
        {'AC_type': 'Slack', 'DC_type': 'PAC', 'AC_node': 'OFW_NL', 'DC_node': 'MTDC4', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 19.87, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC4', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (3.988037 53.067627, 3.960571 53.12535)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'NL9', 'DC_node': 'MTDC5', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 2, 'pol': 2, 'Conv_id': 'Conv_MTDC5', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (4.839478 52.782831, 4.803772 52.742943)'},
        {'AC_type': 'Slack', 'DC_type': 'PAC', 'AC_node': 'OFW_DEC', 'DC_node': 'MTDC6', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 19.87, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 2, 'pol': 2, 'Conv_id': 'Conv_MTDC6', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (6.416016 54.85764, 6.389923 54.901093)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'DE2', 'DC_node': 'MTDC7', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 2, 'pol': 2, 'Conv_id': 'Conv_MTDC7', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (7.918396 53.366124, 8.052802725 53.33233869)'},
        {'AC_type': 'Slack', 'DC_type': 'PAC', 'AC_node': 'OFW_DK', 'DC_node': 'MTDC8', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 29.63, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.00125, 'PR_x': 0.03180538017064047, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 800.0, 'Nconverter': 2, 'pol': 2, 'Conv_id': 'Conv_MTDC8', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (7.316895 56.46249, 7.275696 56.527684)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'DK6', 'DC_node': 'MTDC9', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 2, 'pol': 2, 'Conv_id': 'Conv_MTDC9', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (8.519897 56.353078, 8.552944588 56.35138683)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'GB27', 'DC_node': 'MTDC10', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.00125, 'PR_x': 0.03180538017064047, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 900.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC10', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (-0.126343 53.343993, -0.178528 53.345633)'},
        {'AC_type': 'PV', 'DC_type': 'P', 'AC_node': 'GB14', 'DC_node': 'MTDC11', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1100.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_MTDC11', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (1.304626 52.579688, 1.272295269 52.57403635)'},
        {'AC_type': 'PV', 'DC_type': 'Slack', 'AC_node': 'NO3', 'DC_node': 'NODC1', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 0.0, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_NO1', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (6.679688 58.662725, 6.753403351 58.6700317)'},
        {'AC_type': 'Slack', 'DC_type': 'PAC', 'AC_node': 'OFW_NO', 'DC_node': 'NODC2', 'P_AC': 0.0, 'Q_AC': 0.0, 'P_DC': 19.87, 'T_r': 0.0, 'T_x': 0.0, 'PR_r': 0.0008326446280991736, 'PR_x': 0.021419949910839498, 'Filter_b': 0.0, 'Droop': 0, 'AC_kV_base': 220, 'MVA_rating': 1000.0, 'Nconverter': 1, 'pol': 2, 'Conv_id': 'Conv_NO2', 'lossa': 1.103, 'lossb': 0.887, 'losscrect': 2.885, 'losscinv': 4.371, 'Ucmin': 0.85, 'Ucmax': 1.2, 'geometry': 'LINESTRING (4.75708 57.733971, 4.658203 57.522273)'}
    ]
    Converters_ACDC = pd.DataFrame(Converters_ACDC_data)

    
    # Create the grid
    [grid, res] = pyf.Create_grid_from_data(S_base, nodes_AC, lines_AC, nodes_DC, lines_DC, Converters_ACDC, data_in='pu')
    grid.name = 'North Sea MTDC'
    
    # Add Price Zones:
    pyf.add_price_zone(grid,'BE',97.27,import_pu_L=1,export_pu_G=1,a=0,b=97.27,c=0,import_expand_pu=0)
    pyf.add_price_zone(grid,'DE',95.67,import_pu_L=1,export_pu_G=1,a=0,b=95.67,c=0,import_expand_pu=0)
    pyf.add_price_zone(grid,'DK',81.26,import_pu_L=1,export_pu_G=1,a=0,b=81.26,c=0,import_expand_pu=0)
    pyf.add_price_zone(grid,'GB',108.23,import_pu_L=1,export_pu_G=1,a=0,b=108.23,c=0,import_expand_pu=30)
    pyf.add_price_zone(grid,'NL',95.82,import_pu_L=1,export_pu_G=1,a=0,b=95.82,c=0,import_expand_pu=0)
    pyf.add_price_zone(grid,'NO',79.44,import_pu_L=1,export_pu_G=1,a=0,b=79.44,c=0,import_expand_pu=0)
    pyf.add_offshore_price_zone(grid,'BE','o_BE')
    pyf.add_offshore_price_zone(grid,'DE','o_DE')
    pyf.add_offshore_price_zone(grid,'DK','o_DK')
    pyf.add_offshore_price_zone(grid,'NL','o_NL')
    pyf.add_offshore_price_zone(grid,'NO','o_NO')
    pyf.add_MTDC_price_zone(grid, 'MTDC',linked_price_zones=[],pricing_strategy='avg')

    

    
    # Assign Price Zones to Nodes
    for index, row in nodes_AC.iterrows():
        node_name = nodes_AC.at[index, 'Node_id']
        price_zone = nodes_AC.at[index, 'PZ']
        ACDC = 'AC'
        if price_zone is not None:
            pyf.assign_nodeToPrice_Zone(grid, node_name, price_zone,ACDC)
    
    for index, row in nodes_DC.iterrows():
        node_name = nodes_DC.at[index, 'Node_id']
        price_zone = nodes_DC.at[index, 'PZ']
        ACDC = 'DC'
        if price_zone is not None:
            pyf.assign_nodeToPrice_Zone(grid, node_name, price_zone,ACDC)
    
    # Add Generators
    pyf.add_gen(grid, 'BE4', 'BE4', price_zone_link=True, lf=97.27, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'BE7', 'BE7', price_zone_link=True, lf=97.27, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DE1', 'DE1', price_zone_link=True, lf=95.67, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DE3', 'DE3', price_zone_link=True, lf=95.67, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DE4', 'DE4', price_zone_link=True, lf=95.67, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DE6', 'DE6', price_zone_link=True, lf=95.67, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DK4', 'DK4', price_zone_link=True, lf=81.26, qf=0, MWmax=1744.0000000000002, MWmin=0, MVArmax=581.3333333333334, MVArmin=-581.3333333333334, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'DK7', 'DK7', price_zone_link=True, lf=81.26, qf=0, MWmax=2330.0, MWmin=0, MVArmax=776.6666666666666, MVArmin=-776.6666666666666, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'GB1', 'GB1', price_zone_link=True, lf=108.23, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'GB21', 'GB21', price_zone_link=True, lf=108.23, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'GB23', 'GB23', price_zone_link=True, lf=108.23, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'GB25', 'GB25', price_zone_link=True, lf=108.23, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'NL6', 'NL6', price_zone_link=True, lf=95.82, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'NL10', 'NL10', price_zone_link=True, lf=95.82, qf=0, MWmax=4670.0, MWmin=0, MVArmax=1556.6666666666667, MVArmin=-1556.6666666666667, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'NO8', 'NO8', price_zone_link=True, lf=79.44, qf=0, MWmax=2173.0, MWmin=0, MVArmax=724.3333333333334, MVArmin=-724.3333333333334, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'NO9', 'NO9', price_zone_link=True, lf=79.44, qf=0, MWmax=2173.0, MWmin=0, MVArmax=724.3333333333334, MVArmin=-724.3333333333334, PsetMW=0, QsetMVA=0)
    pyf.add_gen(grid, 'GB20', 'GB20', price_zone_link=True, lf=108.23, qf=0, MWmax=545.0, MWmin=490.5, MVArmax=545.0, MVArmin=-545.0, PsetMW=0.0, QsetMVA=0.0)
    
    
    # Add Renewable Source Zones
    pyf.add_RenSource_zone(grid,'BE')
    pyf.add_RenSource_zone(grid,'DE')
    pyf.add_RenSource_zone(grid,'DK')
    pyf.add_RenSource_zone(grid,'NL')
    pyf.add_RenSource_zone(grid,'NO')

    
    # Add Renewable Sources
    pyf.add_RenSource(grid, 'BE2', 3500.0, ren_source_name='BE2', available=0, zone='BE', price_zone='BE', Offshore=True, MTDC=None)
    pyf.add_RenSource(grid, 'OFW_DEC', 4500.0, ren_source_name='OFW_DEC', available=0, zone='DE', price_zone='DE', Offshore=True, MTDC=None)
    pyf.add_RenSource(grid, 'OFW_DK', 3500.0, ren_source_name='OFW_DK', available=0, zone='DK', price_zone='DK', Offshore=True, MTDC=None)
    pyf.add_RenSource(grid, 'OFW_NL', 2000.0, ren_source_name='OFW_NL', available=0, zone='NL', price_zone='NL', Offshore=True, MTDC=None)
    pyf.add_RenSource(grid, 'OFW_NO', 2000.0, ren_source_name='OFW_NO', available=0, zone='NO', price_zone='NO', Offshore=True, MTDC=None)

    
    # Return the grid
    return grid,res
